package boxml;

require 5.005_62;
use strict;
use warnings;

require Exporter;

our @ISA = qw(Exporter);

our @EXPORT_OK = ( );

our @EXPORT = qw( cel setstyle ftitle
 caixa pv ph page
	
);
our $VERSION = '0.01';

package boxml;

use CGI qw(:all -no_debug);

my %tabAtt;

our %deftab;

my %def;

BEGIN{
   %tabAtt =(border=> "0" ,
            width => "100%",
            CELLSPACING =>"0",
            CELLPADDING =>"0",);

   %deftab=( 
     noborder => { border=>0, bgcolor=>"#EBEBEB", CELLPADDING=>"3", 
            titlefg=>"white", titlebg=>"#548b8e", mbgcolor => "white",},
     whiteborder => {border => 1, bgcolor => "white", CELLPADDING => "3" ,
            titlefg=>"white", titlebg=>"#548b8e", mbgcolor => "white",},
     whiteborder1 => {border => 1, bgcolor => "white", CELLPADDING => "3" ,
          titlefg=>"white", titlebg=>"#77BBBB", mbgcolor => "white",},
     );

   %def = %{$deftab{"whiteborder"}};
}

sub setstyle {
 my($sty,%diff)=@_;
 %def = (%{$deftab{$sty}},%diff); 
}

sub ftitle { 
 my ($l,$c,$r,%v)=@_; 
 my $a = {size=>"+1",color=>$def{titlefg}};
 table( {%tabAtt, border=>"0", bgcolor=> $def{titlebg},CELLPADDING=>"4",%v}, 
   Tr( td({align=>"left"},font($a, "$l&nbsp;")),
       td({align=>"center"},font($a, "$c&nbsp;")),
       td({align=>"right"},font($a, "&nbsp;$r"))))
}

sub caixa{ 
   my ($tit,$c,%v)=@_; 
   my %a= %v;
   delete @a{"width","WIDTH"};
   delete @v{"bgcolor" ,"BGCOLOR","border","BORDER"};
  my $aux = "\n". 
   table({%tabAtt, CELLSPACING =>6},
     Tr(td(
     table({%tabAtt,%def,%a},
        Tr(tdtit($tit)),
        Tr( [map { (ref($_) eq "ARRAY")? td($_->[0],$_->[1]):td($_)} @$c]))))) ;
  cel($aux,%v);
}

sub pv{ 
   my ($c,%v)=@_; 
   my %a= %v;
   delete @a{"width","WIDTH"};
  my $aux = "\n". 
     table({%tabAtt,%a},
        Tr([map { (ref($_) eq "ARRAY")? td($_->[0],$_->[1]):td($_)} @$c])) ;
  cel($aux,%v);
}

sub ph{ 
   my ($c,%v)=@_; 
   my %a= %v;
   delete @a{"width","WIDTH"};
   my $aux = "\n".
      table({%tabAtt, %a},
            Tr((map {(ref($_) eq "ARRAY")
               ? td({valign => "top",%{$_->[0]}},$_->[1])
               : td({valign => "top"           },$_)} @$c)));
   cel($aux,%v);
}

sub page{
     my ($c,%v)=@_; 
     start_html(-title=>"$v{title}",
                  -link => "#142b6e",
                  -vlink => "#336666",
                  -marginwidth=>"0", 
                  -marginheight=>"0") . "\n"
     . table({%tabAtt, bgcolor => $def{mbgcolor},%v },
             Tr([map { (ref($_) eq "ARRAY")
                       ? td($_->[0],$_->[1])
                       : td($_)} @$c]))
     . end_html } ;

sub cel { my ($aux, %v) = @_; 
#if(inctxt("v")orinctxt("h")or inctxt("portal")){[{%v},$aux]}else {$aux}};
[{%v},$aux] };

sub tdtit { my ($t,$col,%v)=@_;
   $t =~ s/!(.*)/$1/ee;
   td({bgcolor => $def{titlebg},%v},
      font({color=> ($col || $def{titlefg})},b($t)))}

1;


__END__

$makefile = $make || "/home/jj/mkport/makefile";

my $filename = shift || die;
my $file = `tail +2 $filename`;

$file =~ s!<make(?:\s+args=(["'])(.*?)\1)?\s*>(.*?)</make>!
          system("make  -s -f $makefile ARG='$2' $3"); `cat $3`!ge;

# use Data::Dumper;
use DB_File;
use Fcntl;     
my $query = new CGI;
my $url= $query->url(-query=>1); 

tie %h, DB_File, "/tmp/mmkport.db", O_RDWR|O_CREAT, 0644, $DB_BTREE;
if ($page = $h{$uurrll}) {print $page;}
else{
                                                                
require XML::DT;
import XML::DT ;

my %tabAtt=(border=> "0" ,
            width => "100%",
            CELLSPACING =>"0",
            CELLPADDING =>"0",);

%deftab=( 
   noborder => { border=>0, bgcolor=>"#EBEBEB", CELLPADDING=>"3", 
          titlefg=>"white", titlebg=>"#548b8e", mbgcolor => "white",},
   whiteborder => {border => 1, bgcolor => "white", CELLPADDING => "3" ,
          titlefg=>"white", titlebg=>"#548b8e", mbgcolor => "white",},
   whiteborder1 => {border => 1, bgcolor => "white", CELLPADDING => "3" ,
          titlefg=>"white", titlebg=>"#77BBBB", mbgcolor => "white",},
     );

%def = %{$deftab{"whiteborder"}};

%ts=();

%spe = ();

%hash =('-type' =>  { v => 'SEQ',       
                      box => 'SEQ',
                      ftitle => "HASH",
                      portal => 'SEQ',
                      h => 'SEQ', }, 
        '-default' => sub { if( $spe{$q}) { &{$spe{$q}}($c) }
                            else          { toxml();}},
        '-outputenc' => 'ISO-8859-1',

   'icon' =>  sub{ cel( "<img src='$v{src}' alt='$c'>",%v) },
   'title' => sub{cel( p(big($c)), 
                        fgcolor => $def{titlefg}, 
                        bgcolor => $def{titlebg}, 
                        %v)},
   'botao' =>  sub{ $q="a"; $c="<img src='$v{src}' alt='$c'>"; toxml(); },
   'portal' => \&port,
   'h' => \&ph,
   'v' => \&pv,
   'box' => \&caixa,
   'cel'   => sub{ cel($c,%v) },
   'case' => \&case,
   'param' => sub{ param($c) || "" },
   'redo'  => sub{ my $query = new CGI({%v});
                   a({href=>$query->url(-query=>1) },$c); }, 
   'ftitle' => \&ftitle,
   'center' => sub{if(inctxt("ftitle")){$c}else{toxml();}},
   'right' => sub{if(inctxt("ftitle")){$c}else{toxml();}},
   'left' => sub{if(inctxt("ftitle")){$c}else{toxml();}},
   'set' => sub{$ts{$v{n}} = $c; ""},
   'put' => sub{$ts{$v{n}} || warn("$v{n} is undefined\n") },
   'author' => sub{ "<i>$c</i> " . 
          ( $v{email} ? a({href=>"mailto:$v{email}"}," - $v{email}") : "");},
   'cat'    => sub{ `cat $c`;} ,
   'catverb' => sub{ my $a=`cat $c`;
                  $a =~ s/\&/\&amp;/g;
                  $a =~ s/</\&lt;/g;
                  $a =~ s/>/\&gt;/g;
                  "<pre>$a</pre>"; } ,
   'inc'   => sub{ dt($c,%hash);} ,
   'do'    => sub{ `$c`;} ,
   'eval'  => sub{ eval($c); },
   'style' => sub{%def = (%{$deftab{$c}},%v) ; ""},
);

$page =  dtstring($file, %hash); 
print $page;
$h{$uurrll}=$page;

sub case{ 
  my $v=1;
  for(keys %v){ my $a= param($_) || ""; 
       if($v{$_} ne $a){ $v=0; last } }
  ($v)? $c : "";
}


# Below is stub documentation for your module. You better edit it!

=head1 NAME

boxml - Perl extension for blah blah blah

=head1 SYNOPSIS

  use boxml;
  blah blah blah

=head1 DESCRIPTION

Stub documentation for boxml, created by h2xs. It looks like the
author of the extension was negligent enough to leave the stub
unedited.

Blah blah blah.

=head2 EXPORT

None by default.

=head1 Example

 boxml::setstyle("noborder");
 print 
  boxml::page([ boxml::ftitle("","Museu da Pessoa", "Verso trotskista"),
                boxml::cel("Verso trotskista"),
                boxml::cel("Verso trotskista"),
  boxml::ph([ 
              boxml::caixa("Titulo",
                [  boxml::cel("Verso trotskista"),
                   "ex1",
                   "ex2",
                   "ex3",
                   "ex4",
                   "ex5",
                   boxml::cel("Verso trotskista",(bgcolor=>"green"))],( width =>"20\%")),
               boxml::caixa("Titulo",
                [  boxml::cel("Verso trotskista"),
                   "Jose Joao",
                   "Jose Joao",
                   "Jose Joao",
                   "Jose Joao",]),
                 boxml::cel("Verso trotskista")]),
                boxml::ftitle("","Museu da Pessoa", "Verso trotskista"),
                boxml::ftitle("","Museu da Pessoa", "Verso trotskista"),
                boxml::ftitle("","Museu da Pessoa", "Verso trotskista"),

  ]
               
  );


=head1 AUTHOR

A. U. Thor, a.u.thor@a.galaxy.far.far.away

=head1 SEE ALSO

perl(1).

=cut
